var utils = require('./utils');

var sploitMixin = {};

sploitMixin.sploitMixinInit = function () {
	this.ipcHandles = {};
};

sploitMixin.withHandle = function (handle, cb) {
	try {
		return cb(handle);
	} finally {
		this.svcCloseHandle(handle);
	}
};

sploitMixin.findUnmappedRegion = function (targetSize) {
	targetSize = utils.pad64(targetSize);

	// skip the first block so nobody tries to map at 0
	var addr = [0, 0];
	var [base, size, state, perm] = this.svcQueryMem(addr, true).assertOk();
	do {
		addr = utils.add2(addr, size);
		[base, size, state, perm] = this.svcQueryMem(addr, true).assertOk();
		if (base[0] !== addr[0] || base[1] !== addr[1]) {
			throw new Error('queryMem base mismatch?');
		}
	} while (size[1] < targetSize[1] || (size[1] === targetSize[1] && size[0] < targetSize[0]) || perm !== 0 || state !== 0);
	return addr;
};

module.exports = sploitMixin;
